﻿var tvfreebox = {
	popupvisible:       false,
	isKeyPressed:       false,
	canSend:            true,
	key:                void(0),
	keyPressTimeout:    void(0),
	checkOptTimeout:    void(0),
	scrollWhellTimeout: void(0),
	version:            'v6',
	boitier:            '1',
	code:               '',
	help:               true,
	showicon:           true,
	directPress:        ['vol_inc', 'vol_dec', 'prgm_inc', 'prgm_dec', 'up', 'down', 'left', 'right'],
	searchCodeVars:     {},
	contains: function (array, element) {
		for(var i = 0; i < array.length; i++) {
			if(array[i]==element) return true;
		}
		return false;
	},
	pressKey: function(keyPressed){
		tvfreebox.isKeyPressed = true;
		tvfreebox.key = keyPressed;
		tvfreebox.keyPressTimeout = setTimeout('tvfreebox.sendKey(' + (tvfreebox.contains(tvfreebox.directPress, keyPressed)  ? 'false' : 'true') + ');', 500);
	},
	keyUp: function(){
		tvfreebox.isKeyPressed = false;
		clearTimeout(tvfreebox.keyPressTimeout);
		tvfreebox.sendKey();
	},
	sendKey: function(longPress, repeat){
		if(tvfreebox.key && tvfreebox.canSend && tvfreebox.code) {
			var xhr = new XMLHttpRequest();
			xhr.open('GET', 'http://hd' + tvfreebox.boitier + '.freebox.fr/pub/remote_control?code=' + tvfreebox.code +
				'&key=' + tvfreebox.key + (longPress ? '&long=true' : '') + (repeat ? '&repeat=' + repeat : '') + '&a=' + Math.random(), true);
			xhr.onreadystatechange = function() {
				if(xhr.readyState==4) tvfreebox.canSend = true;
			};
			tvfreebox.canSend = !tvfreebox.isKeyPressed;
			xhr.send();
		}
		if(tvfreebox.isKeyPressed && tvfreebox.contains(tvfreebox.directPress, tvfreebox.key)) {
			tvfreebox.keyPressTimeout = setTimeout('tvfreebox.sendKey()', 100);
		} else tvfreebox.key = void(0);
	},
	doKeyDown: function(e) {
		if(!tvfreebox.popupvisible) return;
		var t = e || window.event;
		var cde = t.keyCode;
		var shift = t.shiftKey;
		var touche, nb;
		if(!shift && cde>64 && cde<91){
			var pos = cde - 59 - Math.floor(cde / 83) - Math.floor(cde / 90);
			touche = Math.floor(pos/3).toString();
			nb = pos%3 + 1;
			if(cde==83 || cde==90) nb++;
		} else if(cde>95 && cde<106){
			touche = (cde - 96).toString();
			if(!shift) nb = 1;
			else if(cde==96) nb = 2;
			else if(cde==97) nb = 8;
			else if(cde==103 || cde==105) nb = 5;
			else nb = 4;
		} else if(shift && cde>47 && cde<58){
			touche = (cde - 48).toString();
			if(cde==48) nb = 2;
			else if(cde==49) nb = 8;
			else if(cde==55 || cde==57) nb = 5;
			else nb = 4;
		} else {
			nb = 1;
			if(shift){
				switch(cde){
					case  87:
					case 192: touche = 'play';     break;
					case  88:
					case 220: touche = 'stop';     break;
					case  65:
					case  66: touche = 'bwd';      break;
					case  70:
					case  90: touche = 'fwd';      break;
					case  80:
					case  81: touche = 'prev';     break;
					case  78:
					case  83: touche = 'next';     break;
					case  82: touche = 'rec';      break;
					case  27:
					case  77: touche = 'mute';     break;
					case 188: touche = 'info';     break;
					case 190: touche = 'mail';     break;
					case 191: touche = 'help';     break;
					case 223: touche = 'pip';      break;
				}
			} else {
				switch(cde){
					case   8: touche = 'back';     break;
					case  13: touche = 'ok';       break;
					case  17: touche = 'home';     break;
					case  20: touche = 'swap';     break;
					case  27: touche = 'power';    break;
					case  32: touche = '0';        break;
					case  35: touche = 'blue';     break;
					case  36: touche = 'green';    break;
					case  37: touche = 'left';     break;
					case  38: touche = 'up';       break;
					case  39: touche = 'right';    break;
					case  40: touche = 'down';     break;
					case  45: touche = 'red';      break;
					case  46: touche = 'yellow';   break;
					case  48: touche = '2';  nb=5; break;
					case  49: touche = '7';  nb=6; break;
					case  50: touche = '3';  nb=5; break;
					case  51: touche = '1';  nb=7; break;
					case  52: touche = '1';  nb=6; break;
					case  54: touche = '1';  nb=5; break;
					case  55: touche = '3';  nb=6; break;
					case  93: touche = 'list';     break;
					case 33:
					case 106: touche = 'prgm_inc'; break;
					case 107: touche = 'vol_inc';  break;
					case 109: touche = 'vol_dec';  break;
					case 110: touche = '1';        break;
					case 34:
					case 111: touche = 'prgm_dec'; break;
					case 188: touche = '1';  nb=2; break;
					case 192: touche = '8';  nb=5; break;
					case 222: touche = 'tv';       break;
					case 223: touche = '1';  nb=4; break;
				}
			}
		}
		if(!tvfreebox.isKeyPressed && touche) {
			tvfreebox.keyUp();
			tvfreebox.isKeyPressed = true;
			tvfreebox.key = touche;
			tvfreebox.keyPressTimeout = setTimeout('tvfreebox.sendKey(false, ' + nb + ');', tvfreebox.contains(tvfreebox.directPress, tvfreebox.key) ? 500 : 0);
		}
		return false;
	},
	setTitle: function(enable) {
		var areas = document.getElementsByTagName('html:area');
		for(var i=0; i<areas.length; i++) {
			var self = areas[i];
			self.style.cursor = 'pointer';
			if(enable) self.setAttribute('tooltiptext', self.getAttribute('title_bak'));
			else self.setAttribute('tooltiptext', '');
		}
	},
	checkOptions: function() {
		tvfreebox.resetOptionsMessages();
		var boitier = document.getElementById('boitier').value;
		var code = document.getElementById('code').value;
		var xhr = new XMLHttpRequest();
		xhr.open('GET', 'http://hd' + boitier + '.freebox.fr/pub/remote_control?code=' + code + '&key=start&a=' + Math.random(), true);
		xhr.onreadystatechange = function() {
			if(xhr.readyState==4) {
				clearTimeout(tvfreebox.checkOptTimeout);
				tvfreebox.resetOptionsMessages();
				if(xhr.status==200) {
					document.getElementById('opt_mess_ok').style.display = '';
				} else if(xhr.status==403) {
					document.getElementById('opt_mess_code').style.display = '';
				} else if(xhr.status==404) {
					document.getElementById('opt_mess_version').style.display = '';
				}
			}
		};
		tvfreebox.checkOptTimeout = setTimeout(tvfreebox.checkOptionsFailed, 3000);
		xhr.send();
	},
	checkOptionsFailed: function() {
		document.getElementById('opt_mess_timeout').style.display = '';
	},
	resetOptionsMessages: function() {
		document.getElementById('opt_mess_ok').style.display = 'none';
		document.getElementById('opt_mess_code').style.display = 'none';
		document.getElementById('opt_mess_version').style.display = 'none';
		document.getElementById('opt_mess_timeout').style.display = 'none';
	},
	doOnMouseScroll: function(event) {
		var detail = event.detail;
		if(tvfreebox.popupvisible && detail) {
			clearTimeout(tvfreebox.scrollWhellTimeout);
			tvfreebox.scrollWhellTimeout = setTimeout('tvfreebox.pressKey(\'' + (detail>0 ? 'vol_dec' : 'vol_inc') + '\');tvfreebox.keyUp();', 0);
		}
	},
	searchCodeSearch: function() {
		tvfreebox.searchCodeVars.startTime = new Date().getTime();
		tvfreebox.searchCodeVars.searchCodeBoitier = document.getElementById('searchCodeBoitier').value;
		tvfreebox.searchCodeVars.searchCodeStart   = document.getElementById('searchCodeStart').value;
		tvfreebox.searchCodeVars.searchCodeEnd     = document.getElementById('searchCodeEnd').value;
		if(isNaN(tvfreebox.searchCodeVars.searchCodeStart)) {
			tvfreebox.searchCodeVars.searchCodeStart = '10000000';
			document.getElementById('searchCodeStart').value = '10000000';
		}
		if(isNaN(tvfreebox.searchCodeVars.searchCodeEnd)) {
			tvfreebox.searchCodeVars.searchCodeEnd = '99999999';
			document.getElementById('searchCodeEnd').value = '99999999';
		}
		document.getElementById('searchCodeStatus').value = 'recherche en cours...';
		tvfreebox.searchCodeSearchBoucle();
	},
	searchCodeSearchBoucle : function() {
		document.getElementById('searchCodeOutput').value = tvfreebox.searchCodeVars.searchCodeStart;
		var xhr = new XMLHttpRequest();
		xhr.open('GET', 'http://hd' + tvfreebox.searchCodeVars.searchCodeBoitier + '.freebox.fr/pub/remote_control?code=' + tvfreebox.searchCodeVars.searchCodeStart + '&key=start&a=' + Math.random(), true);
		xhr.onreadystatechange = function() {
			if(xhr.readyState==4) {
				if(xhr.status==200) {
					var time = Math.round((new Date().getTime()-tvfreebox.searchCodeVars.startTime)/100)/10;
					document.getElementById('searchCodeStatus').value = 'trouvé en ' + time + 's';
					document.getElementById('searchCodeOutput').removeAttribute('disabled');
				} else if(tvfreebox.searchCodeVars.searchCodeStart<tvfreebox.searchCodeVars.searchCodeEnd) {
					tvfreebox.searchCodeVars.searchCodeStart++;
					var diff = (new Date().getTime()-this.startTime)*2;
					tvfreebox.searchCodeVars.searchCodeWithPause |= diff>10000;
					setTimeout(tvfreebox.searchCodeSearchBoucle, tvfreebox.searchCodeVars.searchCodeWithPause ? diff : 0);
				} else {
					var time = Math.round((new Date().getTime()-tvfreebox.searchCodeVars.startTime)/100)/10;
					document.getElementById('searchCodeStatus').value = 'non trouvé au bout de ' + time + 's';
				}
			}
		};
		xhr.startTime = new Date().getTime();
		xhr.send();
	},
	init: function(e) {
		var prefs = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('tvfreebox.');
		if(prefs.prefHasUserValue('version'))  tvfreebox.version  = prefs.getCharPref('version');
		else prefs.setCharPref('version', 'v6');
		if(prefs.prefHasUserValue('boitier'))  tvfreebox.boitier  = prefs.getCharPref('boitier');
		else prefs.setCharPref('boitier', '1');
		if(prefs.prefHasUserValue('code'))     tvfreebox.code     = prefs.getCharPref('code');
		if(prefs.prefHasUserValue('help'))     tvfreebox.help     = prefs.getBoolPref('help');
		else prefs.setBoolPref('help', true);
		if(prefs.prefHasUserValue('showicon')) tvfreebox.showicon = prefs.getBoolPref('showicon');
		else prefs.setBoolPref('showicon', true);
		var popup1 = document.getElementById('tvfreebox-popup1-image-v5');
		var popup2 = document.getElementById('tvfreebox-popup2-image-v5');
		if(tvfreebox.version=='v5') {
			if(popup1) {
				popup1.style.display = '';
				document.getElementById('tvfreebox-popup1-image-v6').style.display = 'none';
			}
			if(popup2) {
				popup2.style.display = '';
				document.getElementById('tvfreebox-popup2-image-v6').style.display = 'none';
			}
		} else {
			if(popup1) {
				popup1.style.display = 'none';
				document.getElementById('tvfreebox-popup1-image-v6').style.display = '';
			}
			if(popup2) {
				popup2.style.display = 'none';
				document.getElementById('tvfreebox-popup2-image-v6').style.display = '';
			}
		}
		document.getElementById('tvfreebox-status').style.display = tvfreebox.showicon ? '' : 'none';
		document.getElementById('tvfreebox-status').src = 'chrome://tvfreebox/skin/' + tvfreebox.version + '/icon.png';
		document.getElementById('tvfreebox-toolbar-button').className = tvfreebox.version + ' toolbarbutton-1 chromeclass-toolbar-additional';
		tvfreebox.setTitle(tvfreebox.help);
        e.originalTarget.onkeydown = tvfreebox.doKeyDown;
		e.originalTarget.onkeyup   = tvfreebox.keyUp;
		e.originalTarget.addEventListener('DOMMouseScroll', tvfreebox.doOnMouseScroll, false);
	}
};
window.addEventListener('load', tvfreebox.init, false);